## qtile 0.10.6

=== Makefile ===
default:
	@echo "'make check'" for tests
	@echo "'make check-cov'" for tests with coverage
	@echo "'make lint'" for source code checks
	@echo "'make ckpatch'" to check a patch
	@echo "'make clean'" to clean generated files
	@echo "'make man'" to generate sphinx documentation
	@echo "'make update-requirements'" to update the requirements files

.PHONY: check
check:
	pytest --verbose

.PHONY: check-cov
check-cov:
	pytest --verbose --with-cov libqtile --cov-report term-missing

.PHONY: lint
lint:
	flake8 ./libqtile bin/q* bin/iqshell

.PHONY: ckpatch
ckpatch: lint check

.PHONY: clean
clean:
	-rm -rf dist qtile.egg-info docs/_build build/

# This is a little ugly: we want to be able to have users just run
# 'python setup.py install' to install qtile, but we would also like to install
# the man pages. I can't figure out a way to have the 'build' target invoke the
# 'build_sphinx' target as well, so we commit the man pages, since they are
# used in the 'install' target.
.PHONY: man
man:
	python setup.py build_sphinx -b man
	cp build/sphinx/man/* resources/

.PHONY: update-requirements
update-requirements:
	pip-compile requirements.in

=== requirements.txt ===
#
# This file is autogenerated by pip-compile
# To update, run:
#
#    pip-compile --output-file requirements.txt requirements.in
#

cairocffi==0.7.2
cffi==1.6.0
pycparser==2.14           # via cffi
six==1.10.0
xcffib==0.4.2

=== debian/changelog ===
qtile (0.10.6-3) unstable; urgency=medium

  * Fixes Python dependencies to use correct Python version (Closes: #833098)
   - Also removed python{3,}-cffi as these dependencies were not required.

 -- Iain R. Learmonth <irl@debian.org>  Mon, 19 Sep 2016 13:47:38 +0100

qtile (0.10.6-2) unstable; urgency=medium

  * Added postinst and prerm scripts for qtile:
   - Registers and deregisters qtile as an alternative for x-window-manager
     using update-alternatives (Closes: #824539)
  * debian/rules:
   - Re-enabled testing, this has been enabled by an upstream fix to allow
     tests to use xvfb.
  * debian/control:
   - Added Build-Dependencies required for testing
   - Added Provides: x-window-manager to qtile
  * debian/copyright:
   - Removed file paths that followed symlinks so files are referenced only
     by their canonical path.

 -- Iain R. Learmonth <irl@debian.org>  Sun, 29 May 2016 14:31:58 +0100

qtile (0.10.6-1) unstable; urgency=medium

  * New upstream release:
   - qsh has been renamed to qshell. (Closes: #824752)

 -- Iain R. Learmonth <irl@debian.org>  Thu, 26 May 2016 13:15:00 +0100

qtile (0.10.5-1) unstable; urgency=medium

  * Initial release. (Closes: #762637)

 -- Iain R. Learmonth <irl@debian.org>  Thu, 28 Apr 2016 14:34:28 +0100

=== debian/control ===
Source: qtile
Maintainer: Iain R. Learmonth <irl@debian.org>
Section: python
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-python,
               python-all,
               python3-all,
               python-setuptools,
               python3-setuptools,
               python-cffi (>= 1.3.0),
               python3-cffi (>= 1.3.0),
               python-trollius,
               python3-trollius,
               python-xcffib (>= 0.4.0),
               python3-xcffib (>= 0.4.0),
               python-cairocffi (>= 0.7),
               python3-cairocffi (>= 0.7),
               libglib2.0-0,
               libpango1.0-0,
               libpangocairo-1.0-0,
               xvfb,
               xserver-xephyr,
               python-pytest,
               python3-pytest,
               python-pytest-cov,
               python3-pytest-cov,
               xterm,
               x11-apps,
               x11-xserver-utils
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/qtile.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/qtile.git
Homepage: http://qtile.org

Package: python-qtile
Architecture: any
Depends: python-xcffib (>= 0.4.0),
         python-cairocffi (>= 0.7),
         python-trollius,
         libglib2.0-0,
         libpango1.0-0,
         libpangocairo-1.0-0,
         ${misc:Depends},
         ${python:Depends}
Recommends: python-dbus,
            python-mpd,
            python-keyring,
            python-xdg
Provides: ${python:Provides}
Description: This package is a library for developing X window managers (Python 2)
 Qtile is:
   * simple, small and extensible. It's easy to write your own layouts,
     widgets and built-in commands.
   * configured entirely in Python.
   * command-line shell that allows all aspects of Qtile to be manipulated and
     inspected.
   * complete remote scriptability - write scripts to set up workspaces,
     manipulate windows, update status bar widgets and more.
   * unit tested. Qtile's scriptability has made thorough unit testing
     possible, making it one of the best-tested window managers around.
 .
 This package installs the library for Python 2.

Package: python3-qtile
Architecture: any
Depends: python3-xcffib (>= 0.4.0),
         python3-cairocffi (>= 0.7),
         libglib2.0-0,
         libpango1.0-0,
         libpangocairo-1.0-0,
         python3-trollius,
         ${misc:Depends},
         ${python3:Depends}
Recommends: python3-dbus,
            python3-keyring,
            python3-xdg
Provides: ${python3:Provides}
Description: This package is a library for developing X window managers (Python 3)
 Qtile is:
   * simple, small and extensible. It's easy to write your own layouts,
     widgets and built-in commands.
   * configured entirely in Python.
   * command-line shell that allows all aspects of Qtile to be manipulated and
     inspected.
   * complete remote scriptability - write scripts to set up workspaces,
     manipulate windows, update status bar widgets and more.
   * unit tested. Qtile's scriptability has made thorough unit testing
     possible, making it one of the best-tested window managers around.
 .
 This package installs the library for Python 3.

Package: qtile
Architecture: all
Section: x11
Depends: xinit,
         python3-setproctitle,
         python3-qtile,
         ${misc:Depends},
         ${python3:Depends}
Provides: x-window-manager
Description: Small, simple, extensible X11 window manager written in Python
 Qtile is:
   * simple, small and extensible. It's easy to write your own layouts,
     widgets and built-in commands.
   * configured entirely in Python.
   * command-line shell that allows all aspects of Qtile to be manipulated and
     inspected.
   * complete remote scriptability - write scripts to set up workspaces,
     manipulate windows, update status bar widgets and more.
   * unit tested. Qtile's scriptability has made thorough unit testing
     possible, making it one of the best-tested window managers around.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2,python3 --buildsystem=pybuild

## qtile 0.10.7

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 
 .PHONY: lint
 lint:
-	flake8 ./libqtile bin/q* bin/iqshell
+	flake8 ./libqtile bin/q*
 
 .PHONY: ckpatch
 ckpatch: lint check

=== requirements.txt ===
#
# This file is autogenerated by pip-compile
# To update, run:
#
#    pip-compile --output-file requirements.txt requirements.in
#
cairocffi==0.8.0
cffi==1.9.1
pycparser==2.17           # via cffi
six==1.10.0
xcffib==0.5.1

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build -E -W
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext coverage

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Qtile.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Qtile.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Qtile"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Qtile"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

=== docs/requirements.txt ===
mock # for python <= 3.2
sphinx
sphinx_rtd_theme
sphinxcontrib-seqdiag
numpydoc

=== debian/changelog ===
qtile (0.10.7-2ubuntu2) artful; urgency=medium

  * Don't run test expecting availability and permission to access
    hw sensors. Closes: #870051.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Sep 2017 16:06:40 +0200

qtile (0.10.7-2ubuntu1) artful; urgency=medium

  * Really remove dependency on python3-trollius.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 17 Sep 2017 19:00:06 +0200

qtile (0.10.7-2) unstable; urgency=medium

  * Bumps versioned dependency on xcffib to >= 0.5.0

 -- Iain R. Learmonth <irl@debian.org>  Sun, 16 Jul 2017 00:20:01 +0100

qtile (0.10.7-1) unstable; urgency=medium

  * New upstream version (Closes: #852535)
  * Removed dependencies for python-trollius, no longer needed (Closes: #868202)
  * Disabled xterm related tests, cannot allocate pty in build environment

 -- Iain R. Learmonth <irl@debian.org>  Sat, 15 Jul 2017 12:12:35 +0100

=== debian/control ===
--- 
+++ 
@@ -4,63 +4,26 @@
 Priority: optional
 Build-Depends: debhelper (>= 9),
                dh-python,
-               python-all,
                python3-all,
-               python-setuptools,
                python3-setuptools,
-               python-cffi (>= 1.3.0),
                python3-cffi (>= 1.3.0),
-               python-trollius,
-               python3-trollius,
-               python-xcffib (>= 0.4.0),
-               python3-xcffib (>= 0.4.0),
-               python-cairocffi (>= 0.7),
-               python3-cairocffi (>= 0.7),
+               python3-xcffib (>= 0.5.0),
+               python3-cairocffi (>= 0.7.2-2.1),
                libglib2.0-0,
                libpango1.0-0,
                libpangocairo-1.0-0,
                xvfb,
                xserver-xephyr,
-               python-pytest,
                python3-pytest,
-               python-pytest-cov,
                python3-pytest-cov,
                xterm,
                x11-apps,
-               x11-xserver-utils
+               x11-xserver-utils,
+               lm-sensors
 Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/qtile.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/qtile.git
 Homepage: http://qtile.org
-
-Package: python-qtile
-Architecture: any
-Depends: python-xcffib (>= 0.4.0),
-         python-cairocffi (>= 0.7),
-         python-trollius,
-         libglib2.0-0,
-         libpango1.0-0,
-         libpangocairo-1.0-0,
-         ${misc:Depends},
-         ${python:Depends}
-Recommends: python-dbus,
-            python-mpd,
-            python-keyring,
-            python-xdg
-Provides: ${python:Provides}
-Description: This package is a library for developing X window managers (Python 2)
- Qtile is:
-   * simple, small and extensible. It's easy to write your own layouts,
-     widgets and built-in commands.
-   * configured entirely in Python.
-   * command-line shell that allows all aspects of Qtile to be manipulated and
-     inspected.
-   * complete remote scriptability - write scripts to set up workspaces,
-     manipulate windows, update status bar widgets and more.
-   * unit tested. Qtile's scriptability has made thorough unit testing
-     possible, making it one of the best-tested window managers around.
- .
- This package installs the library for Python 2.
 
 Package: python3-qtile
 Architecture: any
@@ -69,7 +32,6 @@
          libglib2.0-0,
          libpango1.0-0,
          libpangocairo-1.0-0,
-         python3-trollius,
          ${misc:Depends},
          ${python3:Depends}
 Recommends: python3-dbus,

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/qtile-$1\.tar\.gz/ \
  https://github.com/qtile/qtile/tags .*/v?(\d\S*)\.tar\.gz

## qtile 0.30.0

=== debian/changelog ===
qtile (0.30.0-1) experimental; urgency=medium

  * New upstream release
  * debian/control
    + Set myself as Maintainer
    + Bump to Standards-Version 4.7.0
    + Update debhelper-compat 13
    + Change to libpango-1.0-0 in B-D
    + Switch to dh-sequence-python3
    + Change arch to all python3-qtile
    + Add python3-libcst, python3-dbus-next, python3-dbus-fast,
      python3-pywayland, libwlroots-0.18-dev, libpython3-all-dev,
      python3-pytest-xvfb, gir1.2-gtk-3.0, libgdk-pixbuf-2.0-dev,
      and librsvg2-dev in B-D
    + Add python3-sphinx, python3-numpydoc in B-D to build manpage.
    + Add Testsuite field
    + Add Rules-Requires-Root field
    + Update vcs-* fields.
  * debian/copyright
    + Rewrite with cme tool
  * debian/patches
    + Remove no_xterm_tests.patch
    + Remvoe remove_unneeded_deps.patch
    + Add 01_change_exec_from_desktop_file.diff patch
      + Use a script to start qtile
    + Add 01_fix_manpage.diff patch
      + Fix lintian warnings
  * Remove d/python*-qtile.install file
  * Add qtile.lintian-overrides file
  * Add d/upstream/metadata file
  * Add d/clean file
  * Install manpage file from qtile.manpages.
  * Add d/tests
  * Update d/watch file

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 25 Jan 2025 22:55:34 -0500

=== debian/control ===
--- 
+++ 
@@ -1,42 +1,56 @@
 Source: qtile
-Maintainer: Iain R. Learmonth <irl@debian.org>
+Maintainer: Daniel Echeverri <epsilon@debian.org>
 Section: python
 Priority: optional
-Build-Depends: debhelper (>= 9),
-               dh-python,
+Build-Depends: debhelper-compat (= 13),
+               dh-sequence-python3,
+               gir1.2-gtk-3.0,
+               libgdk-pixbuf-2.0-dev,
+               libglib2.0-0,
+               libpango-1.0-0,
+               libpangocairo-1.0-0,
+               libpython3-all-dev,
+               librsvg2-dev,
+               libwlroots-0.18-dev,
+               lm-sensors,
                python3-all,
-               python3-setuptools,
+               python3-cairocffi (>= 0.7.2-2.1),
                python3-cffi (>= 1.3.0),
-               python3-xcffib (>= 0.5.0),
-               python3-cairocffi (>= 0.7.2-2.1),
-               libglib2.0-0,
-               libpango1.0-0,
-               libpangocairo-1.0-0,
-               xvfb,
-               xserver-xephyr,
+               python3-dbus-fast,
+               python3-dbus-next,
+               python3-libcst,
+               python3-numpydoc,
+               python3-psutil,
                python3-pytest,
                python3-pytest-cov,
-               xterm,
+               python3-pytest-xvfb,
+               python3-pywayland,
+               python3-setuptools,
+               python3-sphinx,
+               python3-xcffib (>= 0.5.0),
                x11-apps,
                x11-xserver-utils,
-               lm-sensors
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/qtile.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/qtile.git
+               xserver-xephyr,
+               xterm,
+               xvfb
+Testsuite: autopkgtest-pkg-python
+Standards-Version: 4.7.0
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/qtile
+Vcs-Git: https://salsa.debian.org/debian/qtile.git
 Homepage: http://qtile.org
 
 Package: python3-qtile
-Architecture: any
-Depends: python3-xcffib (>= 0.4.0),
+Architecture: all
+Depends: libglib2.0-0,
+         libpango-1.0-0,
+         libpangocairo-1.0-0,
          python3-cairocffi (>= 0.7),
-         libglib2.0-0,
-         libpango1.0-0,
-         libpangocairo-1.0-0,
+         python3-xcffib (>= 0.4.0),
          ${misc:Depends},
-         ${python3:Depends}
-Recommends: python3-dbus,
-            python3-keyring,
-            python3-xdg
+         ${python3:Depends},
+         ${shlibs:Depends}
+Recommends: python3-dbus, python3-keyring, python3-xdg
 Provides: ${python3:Provides}
 Description: This package is a library for developing X window managers (Python 3)
  Qtile is:
@@ -55,9 +69,9 @@
 Package: qtile
 Architecture: all
 Section: x11
-Depends: xinit,
+Depends: python3-qtile,
          python3-setproctitle,
-         python3-qtile,
+         xinit,
          ${misc:Depends},
          ${python3:Depends}
 Provides: x-window-manager

=== debian/tests/control ===
Test-Command: pybuild-autopkgtest
Depends: pybuild-plugin-autopkgtest, xvfb, @, @builddeps@
Restrictions: allow-stderr, skippable
Features: test-name=pybuild-autopkgtest

## qtile 0.31.0

=== Makefile ===
.DEFAULT_GOAL := help

.PHONY: help
help: ## Show this help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {printf "\033[1m%-15s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)

.PHONY: check
check: ## Run the test suite
	@PY=`python --version | sed 's/.*\.\([0-9]*\)\..*/py3\1/'`; \
		echo TOXENV=$$PY tox; \
		TOXENV=$$PY tox

.PHONY: lint
lint: ## Check the source code
	pre-commit run -a

.PHONY: clean
clean: ## Clean generated files
	-rm -rf dist qtile.egg-info docs/_build build/ .tox/ .mypy_cache/ .pytest_cache/ .eggs/

.PHONY: run-ffibuild
run-ffibuild: ## Build FFI modules
	./scripts/ffibuild

.PHONY: update-flake
update-flake: ## Update the Nix flake.lock file, requires Nix installed with flake support, see: https://nixos.wiki/wiki/Flakes
	nix flake update

=== debian/changelog ===
qtile (0.31.0-3) unstable; urgency=medium

  * debian/tests/control
    + Add flaky restriction
    + Add python3-all as a test prerequisite
  * Rename test_backend.sh to testbackend.sh

 -- Daniel Echeverri <epsilon@debian.org>  Sun, 30 Mar 2025 21:12:22 -0500

qtile (0.31.0-2) unstable; urgency=medium

  * debian/rules
    + Add override to execute only backend tests. (Closes: #1101608)
  * debian/control
    + Bump to Standards-Version 4.7.2
    + Remove Testsuite field.
  * debian/tests
    + Add test_backend.sh script to have control the tests.
    + Remove autopkgtest-pkg-python.conf file.

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 29 Mar 2025 16:38:40 -0500

qtile (0.31.0-1) unstable; urgency=medium

  * New upstream version 0.31.0
  * debian/control
    + Remove unnecessary dependencies
    + Add python3-cairo and python3-gi in B-D
    + Change lm-sensors to recommends.
  * debian/patches
    + Refresh 01_fix_manpage.diff patch

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 15 Mar 2025 09:46:02 -0500

qtile (0.30.0-2) unstable; urgency=medium

  * Move to unstable.
  * Add flaky restriction in d/tests/control

 -- Daniel Echeverri <epsilon@debian.org>  Wed, 05 Mar 2025 21:19:25 -0500

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,9 @@
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
                gir1.2-gtk-3.0,
-               libgdk-pixbuf-2.0-dev,
-               libglib2.0-0,
-               libpango-1.0-0,
-               libpangocairo-1.0-0,
                libpython3-all-dev,
                librsvg2-dev,
-               libwlroots-0.18-dev,
-               lm-sensors,
+               python3-gi,
                python3-all,
                python3-cairocffi (>= 0.7.2-2.1),
                python3-cffi (>= 1.3.0),
@@ -33,8 +28,7 @@
                xserver-xephyr,
                xterm,
                xvfb
-Testsuite: autopkgtest-pkg-python
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/qtile
 Vcs-Git: https://salsa.debian.org/debian/qtile.git
@@ -42,15 +36,14 @@
 
 Package: python3-qtile
 Architecture: all
-Depends: libglib2.0-0,
-         libpango-1.0-0,
-         libpangocairo-1.0-0,
+Depends: python3-cairo,
+         python3-gi,
          python3-cairocffi (>= 0.7),
          python3-xcffib (>= 0.4.0),
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
-Recommends: python3-dbus, python3-keyring, python3-xdg
+Recommends: python3-dbus, python3-keyring, python3-xdg, lm-sensors
 Provides: ${python3:Provides}
 Description: This package is a library for developing X window managers (Python 3)
  Qtile is:

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=qtile
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYTHONPATH=$(CURDIR)/debian/python3-qtile
export SETUPTOOLS_SCM_PRETEND_VERSION=$(DEB_VERSION_UPSTREAM)

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_test:
	dh_auto_test -- --system=custom --test-args="PYTHONPATH={build_dir} {interpreter} -m pytest -v test/backend"

override_dh_installman:
	sphinx-build -C -D project=Qtile -b man docs/ debian/tmp/man
	rm -rf $(CURDIR)/debian/tmp/man/.doctrees/
	dh_installman

override_dh_install:
	dh_install
	mkdir -p $(CURDIR)/debian/qtile/usr/bin/
	mv $(CURDIR)/debian/python3-qtile/usr/bin/qtile $(CURDIR)/debian/qtile/usr/bin/

=== debian/tests/control ===
Tests: testbackend.sh
Depends: python3-pytest, python3-all, @, @builddeps@
Restrictions: allow-stderr, flaky

## qtile 0.33.0

=== Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 .PHONY: run-ffibuild
 run-ffibuild: ## Build FFI modules
-	./scripts/ffibuild
+	./scripts/ffibuild -v
 
 .PHONY: update-flake
 update-flake: ## Update the Nix flake.lock file, requires Nix installed with flake support, see: https://nixos.wiki/wiki/Flakes

=== requirements.txt ===
cairocffi >= 1.6.0
cffi >= 1.1.0
xcffib >= 1.4.0
pycairo >= 1.25.1

=== docs/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # You can set these variables from the command line.
 SPHINXOPTS    =
-SPHINXBUILD   = sphinx-build -E -W
+SPHINXBUILD   = sphinx-build -E -W --keep-going
 PAPER         =
 BUILDDIR      = _build
 
@@ -14,7 +14,7 @@
 # the i18n builder cannot share the environment and doctrees with the others
 I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
 
-.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext coverage
+.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext coverage genkeyimg genwidgetscreenshots
 
 help:
 	@echo "Please use \`make <target>' where <target> is one of"
@@ -38,11 +38,12 @@
 	@echo "  linkcheck  to check all external links for integrity"
 	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
 	@echo "  coverage   to run coverage check of the documentation (if enabled)"
+	@echo "  genkeyimg  to generate keybindings images. Will save in _static/keybindings"
 
 clean:
 	-rm -rf $(BUILDDIR)/*
 
-html:
+html: genkeyimg
 	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
 	@echo
 	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."
@@ -157,3 +158,19 @@
 	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
 	@echo "Testing of coverage in the sources finished, look at the " \
 	      "results in $(BUILDDIR)/coverage/python.txt."
+
+genkeyimg:
+	mkdir -p ./_static/keybindings
+	rm -f ./_static/keybindings/*.png
+	../scripts/gen-keybinding-img -o ./_static/keybindings
+	sed -i '/^\.\. LS_PNG/,/^\.\. END_LS_PNG/{/^\.\. image/d}' manual/commands/keybindings.rst
+	sed -i '/^\.\. END_LS_PNG/e find _static/keybindings/* | awk '"'"'{ print length, $$0 }'"'"' | sort -n | cut -d" " -f2- | awk '"'"'{print ".. image:: /" $$1}'"'"'' manual/commands/keybindings.rst
+	@echo
+	@echo "Keybinding images have been generated."
+
+genwidgetscreenshots:
+	rm -rf screenshots/widgets
+	@echo "Generating screenshots for widgets using pytest fixtures."
+	pytest -o python_files="ss_*.py" -o python_functions="ss_*" --backend x11 ../test
+	@echo
+	@echo "Generated widget screenshots"

=== docs/requirements.txt ===
setuptools_scm
# Sphinx 7.0.0 is not currently supported by the sphinx RTD theme
sphinx<7.0.0
sphinx_rtd_theme
funcparserlib==1.0.0a0
numpydoc
pytest
xcffib >= 1.4.0
PyGObject
dbus-fast

=== debian/changelog ===
qtile (0.33.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    + Add xauth and python3-setuptools-scm in B-D.
  * debian/tests/control
    + Add python3-pytest-tornasync in Depends.
  * debian/patches
    + Refresh 01_fix_manpage.diff patch.
  * debian/rules
    + Wrap dh_auto_test with xvfb-run when tests are enabled.

 -- Daniel Echeverri <epsilon@debian.org>  Sun, 05 Oct 2025 09:06:21 -0500

=== debian/control ===
--- 
+++ 
@@ -21,13 +21,15 @@
                python3-pytest-xvfb,
                python3-pywayland,
                python3-setuptools,
+               python3-setuptools-scm,
                python3-sphinx,
                python3-xcffib (>= 0.5.0),
                x11-apps,
                x11-xserver-utils,
                xserver-xephyr,
                xterm,
-               xvfb
+               xvfb,
+               xauth
 Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/qtile

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=qtile
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYTHONPATH = $(CURDIR)/debian/python3-qtile
export SETUPTOOLS_SCM_PRETEND_VERSION = $(DEB_VERSION_UPSTREAM)


%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	xvfb-run dh_auto_test --no-parallel -- --system=custom --test-args="PYTHONPATH={build_dir} {interpreter} -m pytest -v test/backend"
endif

override_dh_installman:
	sphinx-build -C -D project=Qtile -b man docs/ debian/tmp/man
	rm -rf $(CURDIR)/debian/tmp/man/.doctrees/
	dh_installman

override_dh_install:
	dh_install
	mkdir -p $(CURDIR)/debian/qtile/usr/bin/
	mv $(CURDIR)/debian/python3-qtile/usr/bin/qtile $(CURDIR)/debian/qtile/usr/bin/

=== debian/tests/control ===
Tests: testbackend.sh
Depends: python3-pytest, python3-all, python3-pytest-tornasync, @, @builddeps@
Restrictions: allow-stderr, flaky

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/qtile-$1\.tar\.gz/ \
  https://github.com/qtile/qtile/tags .*/v?(\d\S*)\.tar\.gz

## qtile 0.34.0

=== Makefile ===
.DEFAULT_GOAL := help

ifeq ($(QTILE_CI_PYTHON),)
UV_PYTHON_ARG =
else
UV_PYTHON_ARG = --python=$(QTILE_CI_PYTHON)
endif

ifeq ($(QTILE_CI_BACKEND),)
PYTEST_BACKEND_ARG =
else
PYTEST_BACKEND_ARG = --backend=$(QTILE_CI_BACKEND)
endif

TEST_RUNNER = python3 -m pytest
ifeq ($(GITHUB_ACTIONS),true)
TEST_RUNNER = coverage run -m pytest
endif

.PHONY: help
help: ## Show this help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {printf "\033[1m%-15s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)

.PHONY: deps
deps: ## Install all of qtile's dependencies.
	uv sync $(UV_PYTHON_ARG) --all-extras

.PHONY: check
check: deps ## Run the test suite on the latest python
	uv run ./libqtile/backend/wayland/cffi/build.py
	uv run $(UV_PYTHON_ARG) $(TEST_RUNNER) $(PYTEST_BACKEND_ARG)

.PHONY: docs
docs: deps ## Run the sphinx build for the html docs.
	uv run $(MAKE) -C docs html

.PHONY: check-packaging
check-packaging:  ## Check that the packaging is sane
	uv run $(UV_PYTHON_ARG) check-manifest
	uv run $(UV_PYTHON_ARG) python3 -m build --sdist .
	uv run $(UV_PYTHON_ARG) twine check dist/*

.PHONY: lint
lint: ## Check the source code
	pre-commit run -a

.PHONY: clean
clean: ## Clean generated files
	-rm -rf dist qtile.egg-info docs/_build build/ .mypy_cache/ .pytest_cache/ .eggs/

.PHONY: update-flake
update-flake: ## Update the Nix flake.lock file, requires Nix installed with flake support, see: https://nixos.wiki/wiki/Flakes
	nix flake update

.PHONY: build-wayland
build-wayland: ## Build wayland backend
	@python libqtile/backend/wayland/cffi/build.py

.PHONY: build-wayland-debug
build-wayland-debug: ## Build wayland backend with debug symbols
	@echo "Building wayland backend with debug symbols."
	@python libqtile/backend/wayland/cffi/build.py --debug

.PHONY: build-wayland-asan
build-wayland-asan: ## Build wayland backend with address sanitisation support.
	@echo "Building wayland backend with address sanitisation support."
	@echo "When starting qtile, you'll need to set 'LD_PRELOAD=$(gcc -print-file-name=libasan.so)' first."
	@python libqtile/backend/wayland/cffi/build.py --asan

=== docs/Makefile ===
--- 
+++ 
@@ -171,6 +171,6 @@
 genwidgetscreenshots:
 	rm -rf screenshots/widgets
 	@echo "Generating screenshots for widgets using pytest fixtures."
-	pytest -o python_files="ss_*.py" -o python_functions="ss_*" --backend x11 ../test
+	pytest -o python_files="ss_*.py" -o python_functions="ss_*" --backend x11 ../test/widgets/docs_screenshots
 	@echo
 	@echo "Generated widget screenshots"

=== debian/changelog ===
qtile (0.34.0-1) unstable; urgency=medium

  * New upstream version 0.34.0
  * debian/patches
    + Refresh 01_fix_manpage.diff patch
  * debian/control
    + Add pybuild-plugin-pyproject in B-D.
    + Move python3-libcst from Build-Depends to Recommends. (Closes: #1120010)
    + Remove Rules-Requires-Root field
  * debian/tests/testbackend.sh
    + Add conditional check for libcst availability to skip migration tests
      when not installed
  * debian/tests/control
    + Use python3-pytest-asyncio instead of python3-pytest-tornasync to
      avoid event loop closure issues
    + Add python3-aiohttp and python3-anyio required by widget tests
  * debian/copyright
    + Update for upstream source changes, remove entries for
      files no longer present (bin/*, setup.py).
  * debian/watch
    + Update format to version 5

 -- Daniel Echeverri <epsilon@debian.org>  Sun, 30 Nov 2025 21:27:38 -0500

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,6 @@
                python3-cffi (>= 1.3.0),
                python3-dbus-fast,
                python3-dbus-next,
-               python3-libcst,
                python3-numpydoc,
                python3-psutil,
                python3-pytest,
@@ -24,6 +23,7 @@
                python3-setuptools-scm,
                python3-sphinx,
                python3-xcffib (>= 0.5.0),
+               pybuild-plugin-pyproject,
                x11-apps,
                x11-xserver-utils,
                xserver-xephyr,
@@ -31,7 +31,6 @@
                xvfb,
                xauth
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/qtile
 Vcs-Git: https://salsa.debian.org/debian/qtile.git
 Homepage: http://qtile.org
@@ -45,7 +44,7 @@
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
-Recommends: python3-dbus, python3-keyring, python3-xdg, lm-sensors
+Recommends: python3-dbus, python3-keyring, python3-xdg, lm-sensors, python3-libcst
 Provides: ${python3:Provides}
 Description: This package is a library for developing X window managers (Python 3)
  Qtile is:

=== debian/tests/control ===
Tests: testbackend.sh
Depends: python3-pytest, python3-all, python3-pytest-asyncio, python3-aiohttp, python3-anyio, @, @builddeps@
Restrictions: allow-stderr, flaky

=== debian/watch ===
Version: 5

Template: Github
Owner: qtile
Project: qtile

## qtile ebenezer-0.1.18

=== Makefile ===
SHELL := /bin/bash
PIPENV = pipenv
PIPFILE = Pipfile
PYTHON = $(PIPENV) run python

# Precommit hooks
precommit: leaks

leaks-history:
	docker run --rm \
	-v $(PWD):/repo \
	zricethezav/gitleaks:latest \
	detect --source /repo --config /repo/.gitleaks.toml --report-format json --report-path /repo/gitleaks_report.json

leaks:
	docker run --rm \
	-v $(PWD):/repo \
	zricethezav/gitleaks:latest \
    detect --log-opts="HEAD^..HEAD" --source /repo --config /repo/.gitleaks.toml --report-format json --report-path /repo/gitleaks_report.json

install:
	$(PIPENV) install --dev

activate:
	$(PIPENV) shell

test:
	$(PIPENV) run pytest $(file)  $(args)

test-non-ui:
	$(PIPENV) run pytest -m "not ui" $(file)  $(args)

test-ui:
	$(PIPENV) run pytest -m "ui" $(file)  $(args)

format:
	$(PIPENV) run autoflake --remove-all-unused-imports --in-place --recursive .
	$(PIPENV) run isort .
	$(PIPENV) run black .

clean:
	-rm -rf dist qtile.egg-info docs/_build build/ .tox/ .mypy_cache/ .pytest_cache/ .eggs/ pkg/ qtile-ebenezer qtile_ebenezer.egg-info

truncate-logs:
	truncate -s0 ~/.local/share/qtile/qtile.log 

logs:
	cat ~/.local/share/qtile/qtile.log

docs-clean:
	rm -rf docs/_build docs/_static
	mkdir -p docs/_build docs/_static

docs-locally:
	$(MAKE) docs-clean
	$(PIPENV) run sphinx-apidoc -o docs ebenezer/
	$(PIPENV) run sphinx-build -b html docs docs/_build/html

deploy:
	$(MAKE) stubgen
	rm -rf dist/*
	$(PIPENV) run bump2version patch
	$(PIPENV) run python setup.py sdist bdist_wheel
	$(PIPENV) run twine upload dist/*

test:
	$(PIPENV) run pytest $(file)

stubgen:
	$(PIPENV) run stubgen -p ebenezer -o stubs

aur-pkg:
	makepkg -sfc

aur-clean:
	rm -rf qtile-ebenezer dist python-qtile-ebenezer-*.pkg.tar.zst

aur-install:
	$(MAKE) aur-clean aur-pkg
	yay -U python-qtile-ebenezer-*.pkg.tar.zst

local-build:
	$(MAKE) aur-clean
	python -m build --wheel --outdir "qtile-ebenezer/dist"
	python -m installer --destdir="$(PWD)/qtile-ebenezer" qtile-ebenezer/dist/*.whl

test-build:
	$(MAKE) local-build
	qtile-ebenezer/usr/bin/ebenezer --help

local-install:
	# NOTE: remember to run outside of the virtualenv
	$(MAKE) aur-clean
	python -m build --wheel --outdir "qtile-ebenezer/dist"
	python -m installer --destdir="$(PWD)/qtile-ebenezer" qtile-ebenezer/dist/*.whl
	sudo cp -R qtile-ebenezer/usr/lib/python3.12/site-packages/ebenezer /usr/lib/python3.12/site-packages
	sudo cp qtile-ebenezer/usr/bin/ebenezer /usr/bin/ebenezer

aur-setup:
	makepkg --printsrcinfo > .SRCINFO
	rm -rf .aur
	mkdir .aur
	git clone ssh://aur@aur.archlinux.org/python-qtile-ebenezer.git .aur/python-qtile-ebenezer

aur-commit:
	cp PKGBUILD .SRCINFO LICENSE CHANGELOG .aur/python-qtile-ebenezer

	cd .aur/python-qtile-ebenezer && \
	git add PKGBUILD .SRCINFO LICENSE CHANGELOG && \
	git commit -m "$(comment)"

aur-push:
	(cd .aur/python-qtile-ebenezer && git push)

aur-deploy:
	$(MAKE) aur-setup
	$(MAKE) aur-commit comment="Update to $(shell grep '^pkgver=' PKGBUILD | cut -d'=' -f2)"
	$(MAKE) aur-push

.PHONY: precommit leaks-history leaks truncate-logs logs docs-clean docs-locally deploy test install clean
